package enseirb.myinpulse.service.database.old_controllers_to_convert_to_services;

import enseirb.myinpulse.model.User;
import enseirb.myinpulse.repository.UserRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@RestController
public class UserController {

    @Autowired UserRepository userRepository;

    @GetMapping("/User")
    @ResponseBody
    public Iterable<User> allUsers() {
        return this.userRepository.findAll();
    }

    @GetMapping("/User/{id}")
    public User getUserById(@PathVariable Long id) {
        Optional<User> user = userRepository.findById(id);
        if (user.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cet utilisateur n'existe pas");
        }
        return user.get();
    }

    @PostMapping("/User")
    public User addUser(@RequestBody User user) {
        return this.userRepository.save(user);
    }

    @PostMapping("/User/{id}")
    public User updateUser(
            @PathVariable Long id,
            String userSurname,
            String userName,
            String mainMail,
            String secondaryMail,
            String phoneNumber) {
        Optional<User> user = userRepository.findById(id);
        if (user.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "Cet utilisateur n'existe pas");
        }
        if (userName != null) {
            user.get().setUserName(userName);
        }
        if (userSurname != null) {
            user.get().setUserSurname(userSurname);
        }
        if (mainMail != null) {
            user.get().setMainMail(mainMail);
        }
        if (secondaryMail != null) {
            user.get().setSecondaryMail(secondaryMail);
        }
        if (phoneNumber != null) {
            user.get().setPhoneNumber(phoneNumber);
        }
        return this.userRepository.save(user.get());
    }
}
